-- Create Border
local border = CreateFrame("Frame",nil,UIParent)
border:SetSize(200,50)
border:SetFrameStrata("HIGH")
border.t = border:CreateTexture()
border.t:SetAllPoints()
border.t:SetTexture("Interface\\Unitpowerbaralt\\onyxia_horizontal_frame.tga")
border.t:SetAlpha(1.0)
border:SetPoint("CENTER",0,0)
border:Hide()

-- Create Background
local bg = CreateFrame("Frame",nil,UIParent)
bg:ClearAllPoints()
bg:SetSize(150,25)
bg:SetFrameStrata("BACKGROUND")
bg.t = bg:CreateTexture()
bg.t:SetAllPoints()
bg.t:SetTexture(0, 0, 0)
bg.t:SetAlpha(0.4)
bg:SetPoint("LEFT", border, "LEFT", 25, 0)
bg:Hide()

-- Create Bar
local bar = CreateFrame("Frame",nil,UIParent)
bar:ClearAllPoints()
bar:SetSize(0,25)
bar:SetFrameStrata("LOW")
bar.t = bar:CreateTexture()
bar.t:SetAllPoints()
--bar.t:SetTexture("Interface\\Unitpowerbaralt\\onyxia_horizontal_fill.blp") -- Had problems setting textures
bar.t:SetTexture(0, .5, 1)
bar.t:SetAlpha(1.0)
bar:SetPoint("LEFT", border, "LEFT", 25, 0)
bar:Hide()

-- Create Gloss
local bargloss = CreateFrame("Frame",nil,UIParent)
bargloss:ClearAllPoints()
bargloss:SetSize(0,100)
bargloss:SetFrameStrata("MEDIUM")
bargloss.t = bargloss:CreateTexture()
bargloss.t:SetAllPoints()
bargloss.t:SetTexture("Interface\\AddOns\\OnyxiaPowerBarAlt\\Highlight")
bargloss:SetPoint("LEFT", bar, "LEFT", 0, 0)
bargloss:Hide()

-- Create Spark
local spark = CreateFrame("Frame",nil,UIParent)
spark:ClearAllPoints()
spark:SetSize(6.25,50)
spark:SetFrameStrata("MEDIUM")
spark.t = spark:CreateTexture()
spark.t:SetAllPoints()
spark.t:SetTexture("Interface\\Unitpowerbaralt\\onyxia_horizontal_spark.blp")
spark.t:SetAlpha(1.0)
spark.t:SetBlendMode("ADD")
spark:SetPoint("RIGHT", bar, "RIGHT", 2, 0)
spark:Hide()

-- Create Text
local onypowertext = bar:CreateFontString("onyxia_power_text")
onypowertext:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
onypowertext:SetPoint("LEFT", border, "LEFT",200,0)

-- Combat Function (Start)
local function combat_start_func()
  bar:RegisterEvent("UNIT_POWER")
end

-- Combat Function (End)
local function combat_end_func()
  bar:UnregisterEvent("UNIT_POWER")
  bg:Hide()
  border:Hide()
  bargloss:Hide()
  bar:Hide()
  spark:Hide()
end

-- Update Function
local function PowerUpdate()
  local onyxia_power = UnitPower("boss1",10) -- No idea what 10 is, but it tracks onyxia's power!
  if UnitName("boss1") == "Onyxia" then
    bg:Show()
    border:Show()
    bargloss:Show()
    bar:Show()
    spark:Show()
    bar:SetSize(onyxia_power/100*150,25) -- divide by 100 for decimal value (0-1) multiplied by 150 for width percent
    bargloss:SetSize(onyxia_power/100*150,100)
    onypowertext:SetText('|cff007aff'..onyxia_power..'|r')
  else
    bg:Hide()
    border:Hide()
    bargloss:Hide()
    bar:Hide()
    spark:Hide()
    --bar:UnregisterEvent("UNIT_POWER") -- Remove if issues occur
  end
end

local combat_start = CreateFrame("Frame",nil,UIParent)
combat_start:RegisterEvent("PLAYER_REGEN_DISABLED")
combat_start:SetScript("OnEvent", combat_start_func)

local combat_end = CreateFrame("Frame",nil,UIParent)
combat_end:RegisterEvent("PLAYER_REGEN_ENABLED")
combat_end:SetScript("OnEvent", combat_end_func)

bar:SetScript("OnEvent", PowerUpdate);



--[[
Code to display box and move Focus PowerBarAlt anytime you like
Credits to sp00n (Code Left mostly the same as in original addon
http://www.wowinterface.com/downloads/info19025-MovePowerBarAlt.html

Source: http://www.mmo-champion.com/threads/811732-Movable-PlayerPowerBarAlt-problem
Credits to Treeston on the MMO-Champion forums
--]]
---- Set Movable
local b = CreateFrame("Frame", nil, UIParent)
b:SetSize(200,50)
b:SetPoint("TOP", border, "TOP", 0, 0)
b:EnableMouse(true)
border:SetMovable(true)
border:SetUserPlaced(true)
b:SetScript("OnMouseDown", function() border:StartMoving() end)
b:SetScript("OnMouseUp", function() border:StopMovingOrSizing() end)
b.t = b:CreateTexture()
b.t:SetAllPoints()
b.t:SetTexture(0, 0.5, 1)	-- the finest light blue you've ever seen
b.t:SetAlpha(0.8)
b:Hide()

SlashCmdList["ONYXIABAR"]=function() b[b:IsShown() and "Hide" or "Show"](b) end
SLASH_ONYXIABAR1 = "/onybar"
